

-- FailBot w/ Support for : LDB-1.1, Sink-2.0, and configuration via AceOptions

local ADDON_NAME = "FailBoat"

local addon = LibStub("AceAddon-3.0"):NewAddon(ADDON_NAME, "LibSink-2.0", "AceConsole-3.0")

local L	= LibStub("AceLocale-3.0"):GetLocale(ADDON_NAME)

local media = LibStub("LibSharedMedia-3.0") 
local fail = LibStub("LibFail-1.0")

local defaults = {
	profile = {
		sinkoptions = { --[["sink20OutputSink"] = "Popup"]] },
		sound = nil,
	}
}


function addon:SetValue(info, b)
	self.db.profile[info[#info]] = b
end
function addon:GetValue(info)
	return self.db.profile[info[#info]]
end


local options = {
    name = L["addon_name"],
    desc = L["addon_desc"],
    type = "group",
    get = "GetValue",
    set = "SetValue", 
    handler = addon,
    args = {
		output = addon:GetSinkAce3OptionsDataTable(),
	
		sound = {
            name = L["sound_name"],
            desc = L["sound_desc"],
 			type = "select",
			dialogControl = 'LSM30_Sound',
			values = AceGUIWidgetLSMlists.sound,
		},
    },
}

options.args.output.inline = true

local DO = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject(ADDON_NAME, {
		type = "launcher",
		text = L["addon_name"],
		OnClick = function(frame, button)
			LibStub("AceConfigDialog-3.0"):Open(ADDON_NAME)
		end,
})




function addon:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("FailBoatDB", defaults, "Default")

	self:SetSinkStorage(self.db.profile.sinkoptions)

	local acreg = LibStub("AceConfigRegistry-3.0")
	
	acreg:RegisterOptionsTable(ADDON_NAME, options)
	
	local acdia = LibStub("AceConfigDialog-3.0")
	
	acdia:AddToBlizOptions(ADDON_NAME, ADDON_NAME)
	
	addon:RegisterChatCommand(ADDON_NAME:lower(), function() acdia:Open(ADDON_NAME) end)
end


local fail_events = {
	Fail_Sartheron_LavaWaves,
	Fail_Heigan_Dance,
	Fail_Any_VoidZone,
	Fail_Sapphiron_Breath,
	Fail_Frogger,
	Fail_Thaddius_PolaritySwitch,
	Fail_Thaddius_Jump,
}


function addon:OnEnable()
	for _, v in pairs(fail_events) do
		fail.RegisterEvent(self, v, "Fail")
	end

	media.RegisterCallback(self, "LibSharedMedia_Registered", "SharedMedia_Registered")
	media.RegisterCallback(self, "LibSharedMedia_SetGlobal", "SharedMedia_Registered")
end


function addon:OnDisable()
	fail.UnregisterAllEvents(self)
	media.UnregisterAllCallbacks(self)
end

function addon:Fail(event, ...)
	local txt = L[event]:format(...)

	if self.db.sound then
		PlaySound(self.db.sound)
	end

	self:Pour(txt)
end


function addon:SharedMedia_Registered(event, mediatype, name)
    if mediatype == media.MediaType.SOUND then
        -- Update list of sounds?
    end
end